/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void SelectCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void DoneProc();
static void GetValueProc();

static Atom xa_targets, xa_locale, xa_ctext;
static Atom atoms[4];

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, select, paste;
    Arg al[20];
    int ac;
    XTextProperty textprop;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selection", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ƥΰ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [ƥ] ܥ --> ͭ: 쥯ͭ */
    ac = 0;
    select = XmCreatePushButton(panel, "select", al, ac);
    XtAddCallback(select, XmNactivateCallback, SelectCB, text);
    XtManageChild(select);

    /* [ڡ] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    /* (1) 쥯Υåѥȥ */

    /* "TARGETS" Υȥ */
    xa_targets = XmInternAtom(XtDisplay(toplevel), "TARGETS", False);

    /* ѥɡƥȤΥȥ */
    xa_ctext = XmInternAtom(XtDisplay(toplevel), "COMPOUND_TEXT", False);

    /* ʬʸɤΥȥ */
    if (XmbTextListToTextProperty(XtDisplay(toplevel), "", 1,
                                  XTextStyle, &textprop) != Success) {
        fprintf(stderr, "Cannot get encoding info.\n");
        exit(1);
    }
    xa_locale = textprop.encoding;

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* ͭ: [ƥ] ܥΥХå */
static void SelectCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* 쥯ͭ (3ĤΥХåϿ) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, DoneProc))
        /* ͭǤ顤ƥȤĴɽΤ餻 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* ͭ: 쥯νͭ򼺤äȤ˸ƤӽФ */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* 쥯νͭԤǤʤʤä顤Ĵɽ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* ׵: [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* (2) ͭԤ󶡤ǡĴ٤뤿ᡤ"TARGETS" ׵ */
    XtGetSelectionValue(text, XA_PRIMARY, xa_targets, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* ͭ: 쥯Υǡ׵ᤵ줿Ȥ˸ƤӽФ */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;

    if (*selection != XA_PRIMARY)  /* Τ "PRIMARY" 쥯Τ */
        return False;

    /* ׵ᤵ줿åȤ˱Ԥ */
    if (*target == xa_targets) {
        /* (3) "TARGETS" ׵ᤵ줿ͭԤ󶡲ǽʥåȰ֤ */
        atoms[0] = xa_targets;  /* "TARGETS" Υȥ */
        atoms[1] = xa_locale;   /* ͭԤʸ̾Υȥ */
        atoms[2] = xa_ctext;    /* ѥɡƥȤΥȥ */
        atoms[3] = XA_STRING;   /* "STRING" (Ѹƥ) Υȥ */
        *val_ret = atoms;     /* 󶡲ǽʥפΰ */
        *len_ret = 4;         /* 4ĤΥפ󶡲ǽ */
        *type_ret = XA_ATOM;  /* פΥǡϥȥ */
        *format_ret = 32;     /* ȥΥեޥåȤ 32 ӥåñ */
    }
    else if (*target == xa_locale) {
        /* (5) ͭԤʸɤƱ̾׵ᤵ줿 */
        string = XmTextGetString(w);   /* žΤϤ줿ƥ */
        /* ʸɤפƤΤǡʬʸɤΤޤޤž */
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ǹ NULL ɲ */
        *type_ret = xa_locale;         /* ߤθĶʸɤž */
        *format_ret = 8;               /* ʸΥեޥåȤ 8 */
    }
    else if (*target == xa_ctext) {
        /* (6) ѥɡƥȤ׵ᤵ줿 */
        XTextProperty textprop;
        string = XmTextGetString(w);  /* žΤϤ줿ƥ */
        /* ޥХʸ򥳥ѥɡƥȤѴ */
        if (XmbTextListToTextProperty(XtDisplay(w), &string, 1,
                                      XStdICCTextStyle, &textprop) != Success)
            return False;  /* Ѵ˼ (äʸϤ줿) */
        XtFree(string);
        *val_ret = textprop.value;    /* ѥɡƥȤž */
        *len_ret = strlen(textprop.value);
        *type_ret = xa_ctext;         /* ܸʤΤǥѥɡƥ */
        *format_ret = 8;              /* ʸΥեޥåȤ 8 */
    }
    else if (*target == XA_STRING) {
        /* (7) "STRING" (Ѹƥ) Ȥ׵ᤵ줿 */
        string = XmTextGetString(w);   /* žΤϤ줿ƥ */
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ǹ NULL ɲ */
        *type_ret = XA_STRING;         /* ϱѸΥƥȤΤ߰ */
        *format_ret = 8;               /* ʸΥեޥåȤ 8 */
    }
    else {
        return False;  /* ʤ */
    }

    return True;   /* žǡνȤ */
}

/* ׵: 쥯ΥǡäȤ˸ƤӽФ */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* ǡμ˼ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    if (*selection != XA_PRIMARY) { /* Τ "PRIMARY" 쥯Τ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    /* äǡΥפ˸ä» */
    if (*type == XA_ATOM) {
        /* (4) äǡΥפϥȥ */
        /*  "TARGETS" ׵Фֻ */
        int i, j;
        /* äȥΰϡͭԤ󶡲ǽʥפΥꥹ */
        Atom *atomlist = val;
        atoms[0] = xa_locale;
        atoms[1] = xa_ctext;
        atoms[2] = XA_STRING;
        /* 椫顤׵Ԥߤפ򡤼ΥåȤ */
        for (i = 0; i < 3; i++) {
            for (j = 0; j < *len; j++) {
                if (atoms[i] == atomlist[j]) {
                    /* åȤǡƤӥǡ׵ */
                    XtGetSelectionValue(w, XA_PRIMARY, atoms[i],
                                        GetValueProc, NULL,
                                        XtLastTimestampProcessed(XtDisplay(w)));
                    XtFree((char *)val);
                    return;
                }
            }
        }
    }
    else if (*type == xa_locale) {
        /* (8) äǡΥפϡʬʸɤȰ */
        /* ʸɤƱʤΤǡΤޤޥƥȤ˥ڡ */
        XmTextSetString(w, (char *)val);
    }
    else if (*type == xa_ctext) {
        /* (9) äǡΥפϥѥɡƥ */
        XTextProperty textprop;
        char **clist;
        int count;
        /* ѥɡƥȤޥХʸ᤹ */
        textprop.value = val;
        textprop.encoding = *type;
        textprop.format = *format;
        textprop.nitems = *len;
        if (XmbTextPropertyToTextList(XtDisplay(w),
                                      &textprop, &clist, &count) != Success)
            XBell(XtDisplay(w), 0);  /* Ѵ˼Ԥȥ٥ǹ */

        /* äǡƥȡåȤ˥ڡ */
        XmTextSetString(w, clist[0]);
        XFreeStringList(clist);  /* ⤦פʤΤǲ */
    }
    else if (*type == XA_STRING) {
        /* (10) äǡΥפ "STRING" (Ѹƥ) */
        XmTextSetString(w, (char *)val);
    }
    else {
        XBell(XtDisplay(w), 0);  /* פ㤦ȥ٥ǼԤι */
    }
    XtFree((char *)val);
}

/* ͭ: ׵ԤǡäǸƤӽФ */
static void DoneProc(w, selection, target)
    Widget w;
    Atom *selection;
    Atom *target;
{
    /* žɬפʤȤСǼ¹ */
    /* ΥХåϿȤϥץꥱ󤬥ǡ뤳 */
    /* ϿʤäϡXt ưŪ˥ǡ */
}
